# Set the string to draw
s = "Urban"
web = ximport("web")
reload(web)
font("Verdana", 120)
# Create the canvas so that it fits the text with 5 px margins
size(textwidth(s)+10, textheight(s)+10)
# Queue Kuler for themes that match the string
themes = web.kuler.search(s)
# If none result, give a sample
if len(themes) == 0:
    theme = [(1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 1, 1)]
    print "No results! Using sample theme."
# Otherwise, choose the top match
else: theme = themes[0]
# We don't need the results any more
del themes
# Fill the background with the last color in the theme
background(color(theme[4]))
for i in range(len(s)):
    tp = textpath(s[i], textwidth(s[:i])+5, HEIGHT-15)
    #tp.draw() # Draws the underlying path

    # Here are the variables that influence the composition:
    resx = 80 # The horizontal resolution
    resy = 80 # The vertical resolution
    rx = 2.0 # The horizontal randomness each point has
    ry = 2.0 # The vertical randomness each point has
    dotsize = 12.0 # The maximum size of one dot.
    dx = WIDTH / float(resx) # The width each dot covers
    dy = HEIGHT / float(resy) # The height each dot covers

    # We create a grid of the specified resolution.
    # Each x,y coordinate is a measuring point where
    # we check if it falls within the path.

    for x, y in grid(resx, resy):
        sz=random(5.0, dotsize)
        # Create the point that will be checked
        px = x*dx-sz
        py = y*dy-sz
        # Only do something if the point falls within the path bounds.
        # You could add an "else" statement, that draws something in the
        # empty positions.
        if tp.contains(px, py):
            fontsize(sz)
            # Change the color for each point
            fill(choice(theme[:4]))
            text(s[i], px+random(-rx, rx), 
                 py+random(-ry, ry))
    # Set the fontsize back to full
    fontsize(120)
